#
# This file is part of GNU Enterprise.
#
# GNU Enterprise is free software; you can redistribute it 
# and/or modify it under the terms of the GNU General Public 
# License as published by the Free Software Foundation; either 
# version 2, or (at your option) any later version.
#
# GNU Enterprise is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with program; see the file COPYING. If not,
# write to the Free Software Foundation, Inc., 59 Temple Place
# - Suite 330, Boston, MA 02111-1307, USA.
#
# Copyright 2000-2005 Free Software Foundation
#
#
# FILE:
# GFColumn.py
#
# DESCRIPTION:
"""
Column information for GFTree
"""
# NOTES:
#

from GFValue import GFValue
from GFObj import GFObj
import string

#
# GFColumn
#
class GFColumn (GFObj):
  def __init__(self, parent=None):
    GFObj.__init__(self, parent, 'GFColumn')

    # Runtime Variables
    self._inits = [self.initialize]

  def _buildObject(self):
    return GFObj._buildObject(self)

  #
  # Routines called during a phaseInit
  #
  def initialize(self):
    self._form = self.findParentOfType ('GFForm')
    self._tree = self.findParentOfType ('GFTree')
 
    self._tree._colList.append (self)
    #self._tree._colMap[self.name] = self
    print "added column: ", self.name

